
%define _libdir64 %{_prefix}/lib64

Name:           lua
Version:        5.3.0
Release:        1
Summary:        Powerful light-weight programming language
Group:          Development/Languages
License:        MIT
URL:            http://www.lua.org/
Source0:        http://www.lua.org/ftp/%{name}-%{version}.tar.gz
Source1:        lib%{name}-5.1.so-aix32
Source2:        lib%{name}-5.1.so-aix64
Source3:        lib%{name}-5.2.so-aix32
Source4:        lib%{name}-5.2.so-aix64
Patch0:         %{name}-%{version}-aix.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  coreutils
BuildRequires:  readline-devel >= 6.3-5
Requires:       readline >= 6.3-5

%description
Lua is a powerful light-weight programming language designed for
extending applications. Lua is also frequently used as a
general-purpose, stand-alone language. Lua is free software.
Lua combines simple procedural syntax with powerful data description
constructs based on associative arrays and extensible semantics. Lua
is dynamically typed, interpreted from bytecodes, and has automatic
memory management with garbage collection, making it ideal for
configuration, scripting, and rapid prototyping.


%package devel
Summary:        Development files for %{name}
Group:          System Environment/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       readline-devel >= 6.3-5
Requires:       pkg-config

%description devel
This package contains development files for %{name}.


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit
tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CC="xlc"

# first build the 64-bit version
cd 64bit
export OBJECT_MODE=64
make aix
cd src
CreateExportList -X64 lib%{name}.exp lib%{name}.a
${CC} -q64 -qmkshrobj lib%{name}.a -o lib%{name}-5.3.so -bE:lib%{name}.exp -lm
rm -f lib%{name}.a
/usr/bin/ar -X64 -rc lib%{name}.a lib%{name}-5.3.so
rm -f %{name}.exp lua luac
make all CC="xlc" CFLAGS="-O -DLUA_USE_LINUX" MYLIBS="" MYLDFLAGS="-L. -L/opt/freeware/lib64 -L/opt/freeware/lib -lreadline -Wl,-blibpath:/opt/freware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
cd ..

# now build the 32-bit version
cd ../32bit
export OBJECT_MODE=32
make aix
cd src
CreateExportList -X32 lib%{name}.exp lib%{name}.a
${CC} -q32 -qmkshrobj lib%{name}.a -o lib%{name}-5.3.so -bE:lib%{name}.exp -lm
rm -f lib%{name}.a
/usr/bin/ar -X32 -rc lib%{name}.a lib%{name}-5.3.so
rm -f %{name}.exp lua luac
make all CC="xlc" CFLAGS="-O -DLUA_USE_LINUX" MYLIBS="" MYLDFLAGS="-L. -L/opt/freeware/lib -lreadline -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

export PATH=/opt/freeware/bin:$PATH

cd 64bit
export OBJECT_MODE=64
make install INSTALL_TOP=${RPM_BUILD_ROOT}%{_prefix}

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

mv ${RPM_BUILD_ROOT}%{_libdir} ${RPM_BUILD_ROOT}%{_libdir64} 

cd ../32bit
export OBJECT_MODE=32
make install INSTALL_TOP=${RPM_BUILD_ROOT}%{_prefix}

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/%{name}/5.3
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/%{name}/5.3

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}*.so*

# Add the older 5.1 shared members for compatibility with older apps
# (make sure they're set for LOADONLY with 'strip -e')
cp %{SOURCE1} lib%{name}-5.1.so
/usr/bin/strip -X32 -e lib%{name}-5.1.so
/usr/bin/ar -X32 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a lib%{name}-5.1.so
cp %{SOURCE2} lib%{name}-5.1.so
/usr/bin/strip -X64 -e lib%{name}-5.1.so
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a lib%{name}-5.1.so

cp %{SOURCE1} ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}-5.1.so
cp %{SOURCE2} ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}-5.1.so

# Add the older 5.2 shared members for compatibility with older apps
# (make sure they're set for LOADONLY with 'strip -e')
cp %{SOURCE3} lib%{name}-5.2.so
/usr/bin/strip -X32 -e lib%{name}-5.2.so
/usr/bin/ar -X32 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a lib%{name}-5.2.so
cp %{SOURCE4} lib%{name}-5.2.so
/usr/bin/strip -X64 -e lib%{name}-5.2.so
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a lib%{name}-5.2.so

cp %{SOURCE1} ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}-5.2.so
cp %{SOURCE2} ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}-5.2.so

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/pkgconfig
mkdir -p ${RPM_BUILD_ROOT}%{_libdir64}/pkgconfig
cat etc/%{name}.pc | \
    grep -v '^#' | \
    grep -v INSTALL_ | \
    sed 's|/usr/local|/opt/freeware|' \
      > ${RPM_BUILD_ROOT}%{_libdir}/pkgconfig/%{name}.pc
cp ${RPM_BUILD_ROOT}%{_libdir}/pkgconfig/%{name}.pc ${RPM_BUILD_ROOT}%{_libdir64}/pkgconfig/

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/README 32bit/doc/*.html
%doc 32bit/doc/*.css 32bit/doc/*.gif 32bit/doc/*.png
%{_bindir}/*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_mandir}/man1/*
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/5.3
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/5.3
/usr/bin/*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%defattr(-,root,system,-)
%{_includedir}/*
%{_libdir}/pkgconfig/*.pc
%{_libdir64}/pkgconfig/*.pc
/usr/include/*


%changelog
* Tue Jan 20 2015 Michael Perzl <michael@perzl.org> - 5.3.0-1
- updated to version 5.3.0

* Thu Dec 26 2013 Michael Perzl <michael@perzl.org> - 5.2.3-1
- updated to version 5.2.3

* Tue Jun 04 2013 Michael Perzl <michael@perzl.org> - 5.2.2-1
- updated to version 5.2.2

* Sun Jun 17 2012 Michael Perzl <michael@perzl.org> - 5.2.1-1
- updated to version 5.2.1

* Wed May 30 2012 Michael Perzl <michael@perzl.org> - 5.2.0-3
- fixed missing compatibility with lua version 5.1.X

* Sun May 13 2012 Michael Perzl <michael@perzl.org> - 5.2.0-2
- added a missing compatibility symbolic link

* Mon Feb 20 2012 Michael Perzl <michael@perzl.org> - 5.2.0-1
- updated to version 5.2.0

* Mon Feb 20 2012 Michael Perzl <michael@perzl.org> - 5.1.5-1
- updated to version 5.1.5
- removed the GNU autotools patch, added RTL-style shared libraries

* Thu Aug 25 2011 Michael Perzl <michael@perzl.org> - 5.1.4-3
- updated to latest 5.1.4-3 patch

* Thu Oct 06 2010 Michael Perzl <michael@perzl.org> - 5.1.4-2
- fixed some dependency problems

* Wed Nov 11 2009 Michael Perzl <michael@perzl.org> - 5.1.4-1
- first version for AIX V5.1 and higher
